#ifndef _TNB
#define _TNB

#include "SdlTkX.h"

#ifdef BUILD_tk
#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLEXPORT
#endif

EXTERN char *		TkAlignImageData _ANSI_ARGS_((XImage * image, 
				int alignment, int bitOrder));

EXTERN int		TkpCmapStressed _ANSI_ARGS_((Tk_Window tkwin, 
				Colormap colormap));

EXTERN void		TkCreateXEventSource _ANSI_ARGS_((void));

EXTERN void		TkFreeXId _ANSI_ARGS_((TkDisplay * dispPtr));

EXTERN unsigned long	TkpGetMS _ANSI_ARGS_((void));

EXTERN int		TkpScanWindowId _ANSI_ARGS_((Tcl_Interp * interp, 
				CONST char * string, Window * idPtr));

EXTERN unsigned long	TkpGetMS _ANSI_ARGS_((void));


EXTERN void		TkpSetCapture _ANSI_ARGS_((TkWindow * winPtr));

EXTERN void		TkpSetCursor _ANSI_ARGS_((TkpCursor cursor));

EXTERN void		TkpSync _ANSI_ARGS_((Display * display));

EXTERN int		TkpWmSetState _ANSI_ARGS_((TkWindow * winPtr, 
				int state));

EXTERN void		TkFreeWindowId _ANSI_ARGS_((TkDisplay * dispPtr, 
				Window w));

EXTERN void		TkInitXId _ANSI_ARGS_((TkDisplay * dispPtr));

EXTERN void		TkSendCleanup _ANSI_ARGS_((TkDisplay * dispPtr));

EXTERN void		TkWmCleanup _ANSI_ARGS_((TkDisplay * dispPtr));

EXTERN Window		TkUnixContainerId _ANSI_ARGS_((TkWindow * winPtr));

EXTERN int		TkUnixDoOneXEvent _ANSI_ARGS_((Tcl_Time * timePtr));

EXTERN void		TkUnixSetMenubar _ANSI_ARGS_((Tk_Window tkwin, 
				Tk_Window menubar));

#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLIMPORT

#endif /* _TNB */
