declare {
Status			XAllocColor(Display * d, Colormap c, XColor * xp)
}

declare {
Status			XAllocNamedColor(Display * display, 
				Colormap colormap, CONST char * color_name, 
				XColor * screen_def_return, 
				XColor * exact_def_return)
}

declare {
void			XBell(Display * d, int i)
}

declare {
void			XChangeGC(Display * d, GC gc, unsigned long mask, 
				XGCValues * values)
}

declare {
void			XChangeProperty(Display * d, Window w, Atom a1, 
				Atom a2, int i1, int i2, 
				CONST unsigned char * c, int i3)
}

declare {
void			XChangeWindowAttributes(Display * d, Window w, 
				unsigned long ul, XSetWindowAttributes * x)
}

declare {
int			XClipBox(Region r, XRectangle * rect)
}

declare {
int			XCloseDisplay(Display * display)
}

declare {
void			XConfigureWindow(Display * d, Window w, 
				unsigned int i, XWindowChanges * x)
}

declare {
int			XConvertSelection(Display * display, Atom selection, 
				Atom target, Atom property, Window requestor, 
				Time time)
}

declare {
void			XCopyArea(Display * d, Drawable dr1, Drawable dr2, 
				GC g, int i1, int i2, unsigned int ui1, 
				unsigned int ui2, int i3, int i4)
}

declare {
void			XCopyPlane(Display * d, Drawable dr1, Drawable dr2, 
				GC g, int i1, int i2, unsigned int ui1, 
				unsigned int ui2, int i3, int i4, 
				unsigned long ul)
}

declare {
Pixmap			XCreateBitmapFromData(Display * display, Drawable d, 
				CONST char * data, unsigned int width, 
				unsigned int height)
}

declare {
Colormap		XCreateColormap(Display * d, Window w, Visual * v, 
				int i)
}

declare {
GC			XCreateGC(Display * display, Drawable d, 
				unsigned long valuemask, XGCValues * values)
}

declare {
Cursor			XCreateGlyphCursor(Display * d, Font f1, Font f2, 
				unsigned int ui1, unsigned int ui2, 
				XColor * x1, XColor * x2)
}

declare {
XImage *		XCreateImage(Display * d, Visual * v, 
				unsigned int ui1, int i1, int i2, char * cp, 
				unsigned int ui2, unsigned int ui3, int i3, 
				int i4)
}

declare {
Pixmap			XCreatePixmap(Display * display, Drawable d, 
				unsigned int width, unsigned int height, 
				unsigned int depth)
}

declare {
Cursor			XCreatePixmapCursor(Display * d, Pixmap p1, 
				Pixmap p2, XColor * x1, XColor * x2, 
				unsigned int ui1, unsigned int ui2)
}

declare {
Region			XCreateRegion(void)
}

declare {
Window			XCreateWindow(Display * display, Window parent, 
				int x, int y, unsigned int width, 
				unsigned int height, 
				unsigned int border_width, int depth, 
				unsigned int clazz, Visual * visual, 
				unsigned long valuemask, 
				XSetWindowAttributes * attributes)
}

declare {
void			XDefineCursor(Display * d, Window w, Cursor c)
}

declare {
void			XDeleteProperty(Display * d, Window w, Atom a)
}

declare {
int			XDestroyRegion(Region r)
}

declare {
void			XDestroyWindow(Display * d, Window w)
}

declare {
void			XDrawArc(Display * d, Drawable dr, GC g, int i1, 
				int i2, unsigned int ui1, unsigned int ui2, 
				int i3, int i4)
}

declare {
void			XDrawLine(Display * d, Drawable dr, GC g, int x1, 
				int y1, int x2, int y2)
}

declare {
void			XDrawLines(Display * d, Drawable dr, GC g, 
				XPoint * x, int i1, int i2)
}

declare {
void			XDrawPoint(Display * display, Drawable d, GC gc, 
				int x, int y)
}

declare {
void			XDrawRectangle(Display * d, Drawable dr, GC g, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2)
}

declare {
int			XDrawString(Display * display, Drawable d, GC gc, 
				int x, int y, CONST char * string, 
				int length)
}

declare {
int			XDrawString16(Display * display, Drawable d, GC gc, 
				int x, int y, CONST XChar2b * string, 
				int length)
}

declare {
int			XEmptyRegion(Region r)
}

declare {
int			XEqualRegion(Region r1, Region r2)
}

declare {
int			XEventsQueued(Display * display, int mode)
}

declare {
void			XFillArc(Display * d, Drawable dr, GC g, int i1, 
				int i2, unsigned int ui1, unsigned int ui2, 
				int i3, int i4)
}

declare {
void			XFillPolygon(Display * d, Drawable dr, GC g, 
				XPoint * x, int i1, int i2, int i3)
}

declare {
void			XFillRectangle(Display * display, Drawable d, GC gc, 
				int x, int y, unsigned int width, 
				unsigned int height)
}

declare {
void			XFillRectangles(Display * d, Drawable dr, GC g, 
				XRectangle * x, int i)
}

declare {
int			XFlush(Display * display)
}

declare {
void			XForceScreenSaver(Display * display, int mode)
}

declare {
int			XFree(void * data)
}

declare {
void			XFreeColormap(Display * d, Colormap c)
}

declare {
void			XFreeColors(Display * d, Colormap c, 
				unsigned long * ulp, int i, unsigned long ul)
}

declare {
void			XFreeCursor(Display * d, Cursor c)
}

declare {
int			XFreeFont(Display * display, 
				XFontStruct * font_struct)
}

declare {
int			XFreeFontNames(char * * list)
}

declare {
void			XFreeGC(Display * display, GC gc)
}

declare {
void			XFreeModifiermap(XModifierKeymap * x)
}

declare {
int			XFreePixmap(Display * display, Pixmap pixmap)
}

declare {
GContext		XGContextFromGC(GC g)
}

declare {
char *			XGetAtomName(Display * d, Atom a)
}

declare {
Bool			XGetFontProperty(XFontStruct * font_struct, 
				Atom atom, unsigned long * value_return)
}

declare {
Status			XGetGeometry(Display * d, Drawable dr, Window * w, 
				int * i1, int * i2, unsigned int * ui1, 
				unsigned int * ui2, unsigned int * ui3, 
				unsigned int * ui4)
}

declare {
XImage *		XGetImage(Display * d, Drawable dr, int i1, int i2, 
				unsigned int ui1, unsigned int ui2, 
				unsigned long ul, int i3)
}

declare {
int			XGetInputFocus(Display * display, 
				Window * focus_return, 
				int * revert_to_return)
}

declare {
XModifierKeymap *	XGetModifierMapping(Display * d)
}

declare {
XVisualInfo *		XGetVisualInfo(Display * display, long vinfo_mask, 
				XVisualInfo * vinfo_template, 
				int * nitems_return)
}

declare {
Status			XGetWindowAttributes(Display * d, Window w, 
				XWindowAttributes * x)
}

declare {
int			XGetWindowProperty(Display * d, Window w, Atom a1, 
				long l1, long l2, Bool b, Atom a2, Atom * ap, 
				int * ip, unsigned long * ulp1, 
				unsigned long * ulp2, unsigned char * * cpp)
}

declare {
Status			XGetWMColormapWindows(Display * d, Window w, 
				Window * * wpp, int * ip)
}

declare {
int			XGrabKeyboard(Display * d, Window w, Bool b, int i1, 
				int i2, Time t)
}

declare {
int			XGrabPointer(Display * d, Window w1, Bool b, 
				unsigned int ui, int i1, int i2, Window w2, 
				Cursor c, Time t)
}

declare {
int			XGrabServer(Display * display)
}

declare {
Status			XIconifyWindow(Display * d, Window w, int i)
}

declare {
Atom			XInternAtom(Display * display, 
				CONST char * atom_name, Bool only_if_exists)
}

declare {
int			XIntersectRegion(Region reg1, Region reg2, 
				Region newReg)
}

declare {
KeySym			XKeycodeToKeysym(Display * d, unsigned int k, int i)
}

declare {
KeyCode			XKeysymToKeycode(Display * d, KeySym k)
}

declare {
char *			XKeysymToString(KeySym k)
}

declare {
char * *		XListFonts(Display * display, CONST char * pattern, 
				int maxnames, int * actual_count_return)
}

declare {
XHostAddress *		XListHosts(Display * d, int * i, Bool * b)
}

declare {
Font			XLoadFont(Display * display, CONST char * name)
}

declare {
XFontStruct *		XLoadQueryFont(Display * display, CONST char * name)
}

declare {
Status			XLookupColor(Display * d, Colormap c1, 
				CONST char * c2, XColor * x1, XColor * x2)
}

declare {
void			XMapWindow(Display * d, Window w)
}

declare {
void			XMoveResizeWindow(Display * d, Window w, int i1, 
				int i2, unsigned int ui1, unsigned int ui2)
}

declare {
void			XMoveWindow(Display * d, Window w, int i1, int i2)
}

declare {
int			XNextEvent(Display * display, XEvent * event_return)
}

declare {
int			XNoOp(Display * display)
}

declare {
int			XOffsetRegion(Region pRegion, int x, int y)
}

declare {
Display *		XOpenDisplay(CONST char * display_name)
}

declare {
Status			XParseColor(Display * display, Colormap map, 
				CONST char * spec, XColor * colorPtr)
}

declare {
int			XPointInRegion(Region pRegion, int x, int y)
}

declare {
int			XPutImage(Display * display, Drawable d, GC gc, 
				XImage * image, int src_x, int src_y, 
				int dest_x, int dest_y, unsigned int width, 
				unsigned int height)
}

declare {
void			XQueryColors(Display * d, Colormap c, XColor * x, 
				int i)
}

declare {
Bool			XQueryPointer(Display * d, Window w1, Window * w2, 
				Window * w3, int * i1, int * i2, int * i3, 
				int * i4, unsigned int * ui)
}

declare {
Status			XQueryTree(Display * d, Window w1, Window * w2, 
				Window * w3, Window * * w4, 
				unsigned int * ui)
}

declare {
Status			XReconfigureWMWindow(Display * display, Window w, 
				int screen_number, unsigned int mask, 
				XWindowChanges * changes)
}

declare {
int			XRectInRegion(Region region, int rx, int ry, 
				unsigned int rwidth, unsigned int rheight)
}

declare {
void			XRefreshKeyboardMapping(XMappingEvent * x)
}

declare {
int			XReparentWindow(Display * display, Window w, 
				Window parent, int x, int y)
}

declare {
void			XResizeWindow(Display * d, Window w, 
				unsigned int ui1, unsigned int ui2)
}

declare {
Window			XRootWindow(Display * d, int i)
}

declare {
void			XSelectInput(Display * d, Window w, long l)
}

declare {
Status			XSendEvent(Display * d, Window w, Bool b, long l, 
				XEvent * x)
}

declare {
void			XSetClipMask(Display * display, GC gc, Pixmap pixmap)
}

declare {
void			XSetClipOrigin(Display * display, GC gc, 
				int clip_x_origin, int clip_y_origin)
}

declare {
int			XSetCommand(Display * display, Window w, 
				char * * argv, int argc)
}

declare {
void			XSetDashes(Display * display, GC gc, int dash_offset, 
				CONST char * dash_list, int n)
}

declare {
XErrorHandler		XSetErrorHandler(XErrorHandler x)
}

declare {
void			XSetFont(Display * display, GC gc, Font font)
}

declare {
void			XSetForeground(Display * display, GC gc, 
				unsigned long foreground)
}

declare {
void			XSetIconName(Display * d, Window w, CONST char * c)
}

declare {
void			XSetInputFocus(Display * d, Window w, int i, Time t)
}

declare {
void			XSetLineAttributes(Display * display, GC gc, 
				unsigned int line_width, int line_style, 
				int cap_style, int join_style)
}

declare {
int			XSetRegion(Display * display, GC gc, Region r)
}

declare {
void			XSetSelectionOwner(Display * d, Atom a, Window w, 
				Time t)
}

declare {
int			XSetTransientForHint(Display * display, Window w, 
				Window prop_window)
}

declare {
void			XSetTSOrigin(Display * display, GC gc, 
				int ts_x_origin, int ts_y_origin)
}

declare {
void			XSetWindowBackground(Display * d, Window w, 
				unsigned long ul)
}

declare {
void			XSetWindowBackgroundPixmap(Display * d, Window w, 
				Pixmap p)
}

declare {
void			XSetWindowBorder(Display * d, Window w, 
				unsigned long ul)
}

declare {
void			XSetWindowBorderPixmap(Display * d, Window w, 
				Pixmap p)
}

declare {
void			XSetWindowBorderWidth(Display * d, Window w, 
				unsigned int ui)
}

declare {
void			XSetWindowColormap(Display * d, Window w, Colormap c)
}

declare {
void			XSetWMClientMachine(Display * display, Window w, 
				XTextProperty * text_prop)
}

declare {
Status			XSetWMColormapWindows(Display * display, Window w, 
				Window * colormap_windows, int count)
}

declare {
int			XShrinkRegion(Region r, int dx, int dy)
}

declare {
int			XStoreName(Display * display, Window w, 
				CONST char * window_name)
}

declare {
Status			XStringListToTextProperty(char * * list, int count, 
				XTextProperty * text_prop_return)
}

declare {
KeySym			XStringToKeysym(CONST char * c)
}

declare {
int			XSubtractRegion(Region regM, Region regS, 
				Region regD)
}

declare {
int			XSync(Display * display, Bool discard)
}

declare {
int			XSynchronize(Display * display, Bool discard)
}

declare {
int			XTextWidth(XFontStruct * font_struct, 
				CONST char * string, int count)
}

declare {
int			XTextWidth16(XFontStruct * font_struct, 
				CONST XChar2b * string, int count)
}

declare {
Bool			XTranslateCoordinates(Display * d, Window w1, 
				Window w2, int i1, int i2, int * i3, 
				int * i4, Window * w3)
}

declare {
void			XUngrabKeyboard(Display * d, Time t)
}

declare {
void			XUngrabPointer(Display * d, Time t)
}

declare {
int			XUngrabServer(Display * display)
}

declare {
int			XUnionRectWithRegion(XRectangle * rect, 
				Region source, Region dest)
}

declare {
void			XUnmapWindow(Display * d, Window w)
}

declare {
VisualID		XVisualIDFromVisual(Visual * visual)
}

declare {
void			XWarpPointer(Display * d, Window s, Window dw, 
				int sx, int sy, unsigned int sw, 
				unsigned int sh, int dx, int dy)
}

declare {
Status			XWithdrawWindow(Display * d, Window w, int i)
}

declare {
int			XXorRegion(Region sra, Region srb, Region dr)
}


